#!/usr/bin/perl
    eval 'exec /usr/bin/perl -S $0 ${1+"$@"}'
        if $running_under_some_shell;

use File::Basename;


sub parse_sgml
{
  local($sgmlfile) = $_[0];
  local($xmlfile) = $_[1];
  local($noheader) = $_[2];
  my $line = "";
  my $file = "";
  my $SGML = "f$sgmlfile";
  my $XML = "f$xmlfile";

  print "$sgmlfile -> $xmlfile\n";

  if (-f $xmlfile) {
    print "***Warning: $xmlfile already exists\n";
    system("mv $xmlfile $xmlfile~");
  }

  open($SGML, "<$sgmlfile") || die "Cannot open $sgmlfile\n";
  open($XML, ">$xmlfile") || die "Cannot open $xmlfile\n";

  while (<$SGML>) {
    $line = $_;
    if ((/doctype/ || /DOCTYPE/) && $noheader == 0) {
      # Change the file header
      $line =~ s/doctype ([a-z]*) .*\"/DOCTYPE $1 $system/;
      $line =~ s/DOCTYPE ([a-z]*) .*\"/DOCTYPE $1 $system/;
 
      # Print first the XML head
      print $XML '<?xml version="1.0" encoding="iso-8859-1"?>';
      print $XML "\n$line";
 
      $noheader++;
    }
    else {
      $line =~ s//\&agrave;/g;
      $line =~ s//\&eacute;/g;
      $line =~ s//\&ecirc;/g;
      $line =~ s//\&egrave;/g;
      $line =~ s//\&icirc;/g;
      $line =~ s//\&ocirc;/g;
      $line =~ s//\&ugrave;/g;
      $line =~ s//\&ucirc;/g;
      $line =~ s//\&uuml;/g;
      $line =~ s//\&ccedil;/g;
 
      # Case of included files
      if (/ENTITY.*\.sgml/) {
        # Get the included file name
        ($file = $line) =~ s/.*\"(.*)\.sgml\".*\n/$1/;
 
        # Output follow the main output path
        $outfile = dirname($xmlfile) . "/$file";
 
        # Now the included file is the XML one
        $line =~ s/(.*)\"(.*)\.sgml\"/$1\"$outfile.xml\"/;
 
        # Relative or absolute path?
        if (not($file =~ /^\//)) {
          $file = dirname($sgmlfile) . "/$file";
        }
 
        # The included files need not header
        parse_sgml("$file.sgml", "$outfile.xml", 1);
      }
      print $XML $line;
    }
  }

  close($SGML);
  close($XML);
}

#
# Script start
#

if ($#ARGV < 1) {
  print "$0 dtdfile input.sgml [output.xml]\n";
  exit 1;
}

$system = " SYSTEM \"file://$ARGV[0]\"";
$sgmlfile = $ARGV[1];
$xmlfile = basename($sgmlfile, '.sgml');
$xmlfile = dirname($sgmlfile). "/$xmlfile.xml";

shift; shift;
if (@ARGV) {
  $xmlfile = $ARGV[0];
}

parse_sgml($sgmlfile, $xmlfile, 0);

